/*
 Receive and Echo a line from the XBEE Wifi installed in
 Activity Board

*/
#include "simpletools.h"                      
#include "fdSerial.h"

#define MAXCHARS 78                         

int RX = 9, TX = 8;       // XBEEwifi connected pins

fdserial; *xbwifi;

int main()                                    // Main function
{
char aline[80];                               //A line of text from the XBEE
int lineix;                                   //Index to where to store next XBEE rec char
int ch;                                       // Characters from XBEE
unsigned int linecount;                       // Add linecount to each line received from XBEE

  // Add startup code here.
  print("Hi There:\n");
  xbwifi = fdserial_open(RX,TX,0,9600);       // Full Duplex serial to XBEE
  putchar(CLS);                              // Clear terminal screen
  fdserial_rxFlush(xbwifi);                        // Clear Serial Buffer
  pause(100);

// Clear our line buffer to all NULLS
void ClearLine(char *s) {
 // Hard coded for our aline array, 
 for(int i=0;i<80;i++) {
  s[i] = 0;
 }
}


 
  while(1)
  {
    // Add main loop code here.

  //Check for incoming data from iPad Wifi connection
       ch = fdserial_rxCheck(xbwifi);
       if( ch != -1) {
         if(ch == '\n') {
           aline[lineix] = 0;        //Add a NULL to end of line
           print("%c%s",HOME,aline);      // Show it on terminal so we can see what is happening
           writeLine(xbwifi,aline);  // Send it back to iPad
           lineix = 0;                // Get ready for the next line from XBEE
           ClearLine(aline);
           fdserial_rxFlush(xbwifi);
         }
         else {
          aline[lineix] = ch;       // Add next char to line at index
          lineix++;                 // Increment index
          if(lineix > MAXCHARS){          // Limit index to prevent runnning wild
            lineix = MAXCHARS;
          }
         }
       }// End if ch -1
  
  }// End while(1)  
}
